<template>
  <div>
    <div class="row justify-between q-px-md q-mb-sm">
      <q-toggle
        v-model="showDetailedNutrientBalance"
        size="xs"
        dense
      >
        <span class="text-caption text-grey">
          <translate>Show nitrogen balance</translate>
        </span>
      </q-toggle>

      <FertilizationResultDisplaySettingsButton :algorithm-id="algorithmId" />
    </div>

    <template v-if="showBasicNutrientBalance">
      <NutrientBalanceItem
        :npk-elements="recommendationNpkElements"
        :label="$gettext('Recommendation')"
      />
    </template>

    <template v-else>
      <q-expansion-item
        header-class="q-pa-none"
        expand-icon-class="expand-toggle"
        class="result-expansion"
      >
        <template #header>
          <q-item-section>
            <NutrientBalanceItem
              :npk-elements="inputsNpkElements"
              :label="$gettext('Inputs')"
            />
          </q-item-section>
        </template>

        <q-card class="bg-grey-2">
          <q-card-section class="q-pa-none">
            <NutrientBalanceItem
              :npk-elements="fertilizerAppliedNpkElements"
              :label="$gettext('Fertilizers applied')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="mineralizationFromOrganicWasteNpkElements"
              :label="$gettext('Mineralization from organic waste')"
              deemphasize
              class="result-no-expansion"
            />
          </q-card-section>
        </q-card>
      </q-expansion-item>

      <q-expansion-item
        header-class="q-pa-none"
        expand-icon-class="expand-toggle"
        class="result-expansion"
      >
        <template #header>
          <q-item-section>
            <NutrientBalanceItem
              :npk-elements="outputsNpkElements"
              :label="$gettext('Outputs')"
            />
          </q-item-section>
        </template>

        <q-card class="bg-grey-2">
          <q-card-section class="q-pa-none">
            <NutrientBalanceItem
              :npk-elements="immobilizedNpkElements"
              :label="$gettext('Immobilized')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="leachingNpkElements"
              :label="$gettext('Leaching')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="uptakeNpkElements"
              :label="$gettext('Crop uptake')"
              deemphasize
              class="result-no-expansion"
            />
          </q-card-section>
        </q-card>
      </q-expansion-item>

      <q-separator inset />

      <NutrientBalanceItem
        :npk-elements="recommendationNpkElements"
        :label="$gettext('Balance')"
        class="result-no-expansion"
      />
    </template>

    <div class="text-caption text-grey q-ml-md q-mt-sm">
      <translate>All numbers in kg/ha</translate>
    </div>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import NutrientBalanceItem from 'src/pages/fieldbook/fertilization/algorithms/common/components/NutrientBalanceItem'
import FertilizationResultDisplaySettingsButton from 'src/pages/fieldbook/fertilization/algorithms/common/components/FertilizationResultDisplaySettingsButton'
import { resultTypes, convertResults } from 'src/services/fieldbook/fertilization/fertilizationPlan'
import { ICPA_PMN } from 'src/services/fieldbook/fertilization/algorithms'

export default {
  name: 'IcpaPmnNutrientBalance',
  mixins: [PlatformMixin],
  components: {
    NutrientBalanceItem,
    FertilizationResultDisplaySettingsButton
  },
  props: {
    balanceItems: {
      type: Array,
      required: true
    }
  },
  computed: {
    showBasicNutrientBalance () {
      return !this.showDetailedNutrientBalance
    },
    showDetailedNutrientBalance: {
      get () {
        return this.$store.state.appState.showDetailedNutrientBalance
      },
      set (v) {
        this.$store.commit('appState/setShowDetailedNutrientBalance', v)
      }
    },
    recommendationNpkElements () {
      return this.getNpkElements(resultTypes.RECOMMENDATION)
    },
    inputsNpkElements () {
      return this.getNpkElements(resultTypes.INPUTS)
    },
    outputsNpkElements () {
      return this.getNpkElements(resultTypes.OUTPUTS)
    },
    leachingNpkElements () {
      return this.getNpkElements(resultTypes.LEACHING)
    },
    uptakeNpkElements () {
      return this.getNpkElements(resultTypes.UPTAKE)
    },
    fertilizerAppliedNpkElements () {
      return this.getNpkElements(resultTypes.FERTILIZER_APPLIED)
    },
    mineralizationFromOrganicWasteNpkElements () {
      return this.getNpkElements('mineralized_nitrogen_from_organic_waste')
    },
    immobilizedNpkElements () {
      return this.getNpkElements('immobilized_nitrogen')
    },
    algorithmId () {
      return ICPA_PMN
    }
  },
  methods: {
    getNpkElements (resultType) {
      return convertResults(this.balanceItems.filter(recommendation => recommendation.result_type === resultType))
    }
  }
}
</script>

<style scoped>
.result-expansion :deep(.expand-toggle) {
  padding-left: 0;
  padding-right: 16px
}
.result-no-expansion {
  padding-right: 40px;
}
</style>
